Subject: Re: [PATCH] powerpc: don't re-issue spinlock typedef that breaks older gcc

From: Paul Gortmaker <[email-masked]>
Date: Tue, 28 Jan 2014 12:49:56 -0500

On 14-01-28 12:28 PM, Aneesh Kumar K.V wrote:
> Paul Gortmaker <[email-masked]> writes:
> 
>> Commit b3084f4db3aeb991c507ca774337c7e7893ed04f ("powerpc/thp: Fix
>> crash on mremap") added a "typedef struct spinlock spinlock_t;"
>> which on gcc 4.5.2 (and possibly other versions) causes many of:
>>
>> include/linux/spinlock_types.h:76:3: error: redefinition of typedef 'spinlock_t'
>> arch/powerpc/include/asm/pgtable-ppc64.h:563:25: note: previous declaration of 'spinlock_t' was here
>> In file included from include/linux/mutex.h:15:0,
>>                  from include/linux/notifier.h:13,
>>                  from include/linux/pm_qos.h:8,
>>                  from include/linux/netdevice.h:28,
>>                  from drivers/net/wireless/ath/wil6210/wil6210.h:20,
>>                  from drivers/net/wireless/ath/wil6210/debug.c:17:
>>
>> It appears that somewhere between gcc 4.5.2 and 4.6.3 this
>> redefinition restriction was lifted.  Using the proper header
>> from within !ASSEMBLY seems to fix it up in an acceptable way.
>>
>> Cc: Aneesh Kumar K.V <[email-masked]>
>> Cc: Kirill A. Shutemov <[email-masked]>
>> Cc: Benjamin Herrenschmidt <[email-masked]>
>> Signed-off-by: Paul Gortmaker <[email-masked]>
>> ---
>>
> 
> 
> http://mid.gmane.org/[email-masked]
> 
> This was posted earlier.

I see.  Well I guess Ben didn't use it since it is the same as the
temporary not-signed-off-by hack patch I posted earlier as well.

https://lkml.org/lkml/2014/1/27/584

I believe what I've posted here below to be the proper fix.

Paul.
--

> 
> 
> 
>> [ Note that b3084f4db3 isn't mainline yet, it is currently in
>>   benh/powerpc.git #merge -- but is headed there soon via:
>>              https://lkml.org/lkml/2014/1/27/599           ]
>>
>>  arch/powerpc/include/asm/pgtable-ppc64.h | 3 ++-
>>  1 file changed, 2 insertions(+), 1 deletion(-)
>>
>> diff --git a/arch/powerpc/include/asm/pgtable-ppc64.h b/arch/powerpc/include/asm/pgtable-ppc64.h
>> index d27960c89a71..3b638411646a 100644
>> --- a/arch/powerpc/include/asm/pgtable-ppc64.h
>> +++ b/arch/powerpc/include/asm/pgtable-ppc64.h
>> @@ -111,6 +111,8 @@
>>
>>  #ifndef __ASSEMBLY__
>>
>> +#include <linux/spinlock_types.h>
>> +
>>  /*
>>   * This is the default implementation of various PTE accessors, it's
>>   * used in all cases except Book3S with 64K pages where we have a
>> @@ -560,7 +562,6 @@ extern void pmdp_invalidate(struct vm_area_struct *vma, unsigned long address,
>>  			    pmd_t *pmdp);
>>
>>  #define pmd_move_must_withdraw pmd_move_must_withdraw
>> -typedef struct spinlock spinlock_t;
>>  static inline int pmd_move_must_withdraw(spinlock_t *new_pmd_ptl,
>>  					 spinlock_t *old_pmd_ptl)
>>  {
>> -- 
>> 1.8.5.2
>